#include <stdio.h>
#include <sys/mman.h>

#define FPPLSETVREG 0xC0000910
#define SYS_CLK_FREQ 7372800

void CPUClockAdjust(unsigned speed)
{
	unsigned short &value;
	unsigned short mdiv = 0;
	unsigned short pdiv = 3;
	unsigned short scale = 0;
	int mem_fd;

	mdiv = (pdiv * speed*1000*1000) / SYS_CLK_FREQ;
	mdiv = ((mdiv-8)<<8) & 0xff00;
	pdiv = ((pdiv-2)<<2) & 0xfc;
	scale &= 3;

	mem_fd = open("/dev/mem", O_RDWR|O_SYNC);
	if(mem_fd > 0) {
		value = (unsigned short *) mmap( 0, 2, PROT_READ|PROT_WRITE, MAP_SHARED, mem_fd, FPPLSETVREG );
		if(value) {
			*value = mdiv | pdiv | scale;
			printf ("Clock Adjust : %d MHz\n",speed);
			munmap(value, 2);
		}
		close(mem_fd);
	}
}
