	.section	".init"
	.code 32
	.align
	.global _start

_start:
	ldr pc, =_xxinit @ Reset
	ldr pc, =_undefi @ Undefined instruction
	ldr pc, =_undefi @ Software Interrupt
	ldr pc, =_undefi @ Prefetch abort
	ldr pc, =_undefi @ Data abort
	ldr pc, =_undefi @ Reserved
	ldr pc, =_undefi @ IRQ
	ldr pc, =_undefi @ FIQ

_xxinit:


	ldr sp, =0x100000		@ setup stack
	sub sp, sp, #4

	mov r0, #63			@ region data
	mcr p15, 0, r0, c6, c0, 0
	mcr p15, 0, r0, c6, c0, 1

					@ set up region 1 which is the first 2 megabytes.
	mov r0, #0x00000027		@ region data
	mcr p15, 0, r0, c6, c1, 0
	mcr p15, 0, r0, c6, c1, 1

					@ set region 1 to be cacheable (so the first 2M will be cacheable)
	mov r0, #2
	mcr p15, 0, r0, c2, c0, 0
	mcr p15, 0, r0, c2, c0, 1

					@ set region 1 to be bufferable too (only data)
	mcr p15, 0, r0, c3, c0, 0

					@ set protection on for all regions
	mov r0, #15
	mcr p15, 0, r0, c5, c0, 0
	mcr p15, 0, r0, c5, c0, 1

	mrc p15, 0, r0, c1, c0, 0	@ fetch current control reg
	orr r0, r0, #1			@ 0x00000001: enable protection unit
	orr r0, r0, #4			@ 0x00000004: enable D cache
	orr r0, r0, #0x1000		@ 0x00001000: enable I cache
	orr r0, r0, #0xC0000000		@  0xC0000000: async+fastbus
	mcr p15, 0, r0, c1, c0, 0	@ set control reg
	
	mrs r0, cpsr
	bic r0, r0, #0x80
	msr cpsr_cxsf, r0

	bl main				@ run main()
	b _xxinit			@ and restart

_undefi:
					@ todo: blink the battery LED when this situation arrises
	b _start
