OUTPUT_FORMAT("elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_start)

MEMORY
{
	ram : ORIGIN = 0x0, LENGTH = 1M
}

SECTIONS
{
	.init : 
	{
		KEEP (*(.init))
		. = ALIGN(4);
	} >ram = 0xff

	.text : 
	{
		*(EXCLUDE_FILE (*text.iwram*) .text)
		*(.text.*)
		*(.stub)
		*(.gnu.warning)
		*(.gnu.linkonce.t*)
		*(.glue_7)
		*(.glue_7t)
		. = ALIGN(4);
	} >ram = 0xff

	.fini :
	{
		KEEP (*(.fini))
		. = ALIGN(4);
	} >ram

	.rodata :
	{
		*all.rodata*(*)
		*(.roda)
		*(.rodata.*)
		*(.gnu.linkonce.r*)
		SORT(CONSTRUCTORS)
		. = ALIGN(4);
	} >ram

	.data : 
	{
		*(.data)
		*(.data.*)
		*(.gnu.linkonce.d*)
		CONSTRUCTORS
		. = ALIGN(4);
	} >ram
	.bss : 
	{
		*(.bss)
		*(.dynbss)
		*(.gnu.linkonce.b*)
		*(COMMON)
		. = ALIGN(4);
	} >ram


	_end = . ;
	__end__ = . ;
	PROVIDE (end = _end);
}
