OUTPUT_FORMAT("elf32-littlearm", "elf32-bigarm", "elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_start)

MEMORY
{
  ram      (rw)  : ORIGIN = 0x0, LENGTH = 0x01000000 
}

SECTIONS
{
	. = 0x0;

	.init : 
	{
		KEEP (*(.init))
		. = ALIGN(4);
	} >ram
	
	.text : 
	{
		KEEP (*(.text))
		. = ALIGN(4);
	} >ram

	.fini :
	{
		KEEP (*(.fini))
		. = ALIGN(4);
	} >ram
	
	.ctors :
	{
		KEEP (*crtbegin.o(.ctors))
		KEEP (*(EXCLUDE_FILE (*crtend.o) .ctors))
		KEEP (*(SORT(.ctors.*))) 
		KEEP (*(.ctors))
		. = ALIGN(4);
	} >ram
	
	.dtors :
	{
		KEEP (*crtbegin.o(.dtors))
		KEEP (*(EXCLUDE_FILE (*crtend.o) .dtors))
		KEEP (*(SORT(.dtors.*)))
		KEEP (*(.dtors))
		. = ALIGN(4);
	} >ram
  
	.rodata :
	{
		KEEP (*(.rodata))
		. = ALIGN(4);
	} >ram
  
	.eh_frame :
	{
		KEEP (*(.eh_frame))
		. = ALIGN(4);
	} >ram

	.gcc_except_table :
	{
		*(.gcc_except_table)
		. = ALIGN(4);
	} >ram

	.data ALIGN(4) : 
	{
		*(.data)
		*(.data.*)
		*(.gnu.linkonce.d*)
		CONSTRUCTORS
		. = ALIGN(4);
	} >ram

	.bss ALIGN(4) : 
	{
		*(.bss)
		*(.dynbss)
		*(.gnu.linkonce.b*)
		*(COMMON)
		. = ALIGN(4);
	} >ram


	.stab 0 : { *(.stab) }
	.stabstr 0 : { *(.stabstr) }
	.stab.excl 0 : { *(.stab.excl) }
	.stab.exclstr 0 : { *(.stab.exclstr) }
	.stab.index 0 : { *(.stab.index) }
	.stab.indexstr 0 : { *(.stab.indexstr) }
	.comment 0 : { *(.comment) }

	.debug          0 : { *(.debug) }
	.line           0 : { *(.line) }

	.debug_srcinfo  0 : { *(.debug_srcinfo) }
	.debug_sfnames  0 : { *(.debug_sfnames) }

	.debug_aranges  0 : { *(.debug_aranges) }
	.debug_pubnames 0 : { *(.debug_pubnames) }

	.debug_info     0 : { *(.debug_info) }
	.debug_abbrev   0 : { *(.debug_abbrev) }
	.debug_line     0 : { *(.debug_line) }
	.debug_frame    0 : { *(.debug_frame) }
	.debug_str      0 : { *(.debug_str) }
	.debug_loc      0 : { *(.debug_loc) }
	.debug_macinfo  0 : { *(.debug_macinfo) }

	.debug_weaknames 0 : { *(.debug_weaknames) }
	.debug_funcnames 0 : { *(.debug_funcnames) }
	.debug_typenames 0 : { *(.debug_typenames) }
	.debug_varnames  0 : { *(.debug_varnames) }
}
